<img src="https://github.com/magenta/magenta/blob/main/magenta-logo-bg.png" height="75">

[![Build Status](https://github.com/magenta/note-seq/workflows/build/badge.svg)](https://github.com/magenta/note-seq/actions?query=workflow%3Abuild)
 [![PyPI version](https://badge.fury.io/py/note-seq.svg)](https://badge.fury.io/py/note-seq)


**[Magenta](https://g.co/magenta)** is a research project exploring the role of machine learning
in the process of creating art and music.

This is the home for our serializable `NoteSequence` representation along with
utilities for:

* creating them from various formats (e.g., MIDI, abc, MusicXML)
* manipulating them (e.g., slicing, quantizing)
* extracting components (e.g., melodies, drum tracks, chord)
* exporting them (e.g., to MIDI or audio)
* or converting them to representations useful for model training (e.g., one-hot tensors)

To learn more see the main [magenta repo](https://github.com/magenta/magenta) and have look at the [hello magenta](https://colab.research.google.com/notebooks/magenta/hello_magenta/hello_magenta.ipynb) notebook.

## Installation

`pip install note-seq`

## Notes

Importing `note-seq` increases the value of `pretty_midi.pretty_midi.MAX_TICK` to `1e10`. This may change the expected behavior of `pretty_midi` when using it alongside of `note-seq`. For example, loading corrupted MIDI files with `pretty_midi` may result in out of memory errors.
